#!/bin/sh

TMPDIR="/mnt/ramdisk"
CLOUD_LOG="cloud_log"
CLOUD_LOG_TAR_GZ="${TMPDIR}/cloud_log.tar.gz"
PUNCHD_LOG_PATH="/tmp/.punchd/"
EVENTNOTIFYD_LOG_PATH="/tmp/.eventnotifyd/"
P2PPROXYAPIS_LOG_PATH="/tmp/.p2pproxy/"
CONTENT_LENGTH="0"
CLOUD_VADP_DAEMON_PATH="/mnt/flash2/unifs/usr/bin"
CLOUD_VADP_LIB_PATH="/mnt/flash2/unifs/usr/lib"
CLOUD_VADP_PATH="`cat /mnt/flash2/unifs/etc/conf.d/cloud_vadp_path`"
CLOUD_VADP_VERSION="`cat ${CLOUD_VADP_PATH}/vadp.xml | grep \"<version>\" | awk -F'>' '{print $2}' | awk -F'<' '{print $1}'`"

fetch_p2pproxyapis_log()
{
	P2PPROXYAPIS_LOG="`ls ${P2PPROXYAPIS_LOG_PATH}`"
	if [ -n "${P2PPROXYAPIS_LOG}" ] ; then
		for log_file in ${P2PPROXYAPIS_LOG}
		do
			echo "====== ${log_file} ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
			cat ${P2PPROXYAPIS_LOG_PATH}${log_file} >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
		done
	fi
}

Create_Cloud_Log()
{
	cd ${TMPDIR}
	export LD_LIBRARY_PATH="${CLOUD_VADP_LIB_PATH}:${LD_LIBRARY_PATH}"
	echo "====== Cloud VADP version ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
	echo "${CLOUD_VADP_VERSION}" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
	echo "====== punchd version ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
	${CLOUD_VADP_DAEMON_PATH}/punchd -v >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
	echo "====== eventnotifyd version ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
	${CLOUD_VADP_DAEMON_PATH}/eventnotifyd -v >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}

	PUNCHD_LOG="`ls ${PUNCHD_LOG_PATH}`"
	if [ -n "${PUNCHD_LOG}" ] ; then
		for log_file in ${PUNCHD_LOG}
		do
			echo "====== ${log_file} ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
			cat ${PUNCHD_LOG_PATH}${log_file} >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
		done
	fi

	EVENTNOTIFYD_LOG="`ls ${EVENTNOTIFYD_LOG_PATH}`"
	if [ -n "${EVENTNOTIFYD_LOG}" ] ; then
		for log_file in ${EVENTNOTIFYD_LOG}
		do
			echo "====== ${log_file} ======" >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
			cat ${EVENTNOTIFYD_LOG_PATH}${log_file} >> ${CLOUD_LOG} && echo >> ${CLOUD_LOG}
		done
	fi

	#YungChih@20170913
	fetch_p2pproxyapis_log

	echo "====== End of cloud log ======" >> ${CLOUD_LOG}
	tar zcf ${CLOUD_LOG_TAR_GZ} ${CLOUD_LOG}
	CONTENT_LENGTH="`ls -l ${CLOUD_LOG_TAR_GZ} | awk -F' ' '{print $5}'`"
	rm -f ${CLOUD_LOG}
}

# Get logs of punchd and eventnotifyd
Create_Cloud_Log

# Response HTTP header and payload
echo -ne "Content-type: text/plain\r\n"
echo -ne "Content-Disposition: attachment; filename=cloud_VADP_${CLOUD_VADP_VERSION}.tar.gz\r\n"
echo -ne "Content-length:${CONTENT_LENGTH}\r\n\r\n"
cat ${CLOUD_LOG_TAR_GZ}>&1
rm -f ${CLOUD_LOG_TAR_GZ}

