#! /bin/sh

# Response HTTP header
echo -ne "Content-type: text/plain\r\n"
echo -ne "Cache-control: no-cache\r\n"
echo -ne "Pragma: no-cache\r\n"
echo -ne "\r\n"

if [ $REQUEST_METHOD = POST ] ; then
	strparam=`cat $stdin | cut -c1-$CONTENT_LENGTH`
else
	strparam=$QUERY_STRING
fi
strparam=`decode.sh $strparam`

# Check input parameter
SWITCH_ACTION="${strparam}"
if [ -z "${SWITCH_ACTION}" ] || [ "${SWITCH_ACTION}" != "on" -a "${SWITCH_ACTION}" != "off" ] ; then
	echo "Usage:"
	echo "Turn on cloud service: /cloud/switch_cloud_service.cgi?on"
	echo "Turn off cloud service: /cloud/switch_cloud_service.cgi?off"
	exit 1
fi

CLOUD_CONFIG_FILE="/mnt/flash2/unifs/etc/conf.d/config_cloud.conf"
CLOUD_VADP_PATH="`cat /mnt/flash2/unifs/etc/conf.d/cloud_vadp_path`"
SWITCH_CLOUD_SERVICE="${CLOUD_VADP_PATH}/script/switch_cloud_service"

# Get cloud status
source ${CLOUD_CONFIG_FILE}

# Apply request
if [ "${SWITCH_ACTION}" = "on" ] ; then
	if [ "${cloud_enable}" = "0" ] ; then
		nohup ${SWITCH_CLOUD_SERVICE} on > /tmp/nohup.switch_cloud_service 2>&1 &
	fi
	echo "cloud_enable='1'"
elif [ "${SWITCH_ACTION}" = "off" ] ; then
	if [ "${cloud_enable}" = "1" ] ; then
		nohup ${SWITCH_CLOUD_SERVICE} off > /tmp/nohup.switch_cloud_service 2>&1 &
	fi
	echo "cloud_enable='0'"
fi

exit 0

