/* Global variable */
var cloud_enable = "";
var cloud_status = "";
var cloud_deviceid = "";
var system_hostname = "";

/* General rules for EZBtnSwitch */
new DG.OnOffSwitchAuto({
	cls: '.custom-switch',
	width: 70,
	listener: function(name, checked){
		if (checked === true)
			EZBtnSwitchOn();
		else // checked == false
			EZBtnSwitchOff();
	}
});

var fnAutoResize = function()
{
	var topForm_height = 56;
	var content_height = 900;
	var ezcontent_height = 795;
	var EZConnect_method_height = 385;
	var browser_height = $(window).height();

	if (browser_height < eval(topForm_height + content_height))
	{
		var max_decreasing_height = 56;
		var height_diff = eval(topForm_height + content_height - browser_height);
		height_diff = Math.min(max_decreasing_height, height_diff);

		$("#container").css("height", eval(content_height - height_diff) + "px");
		$("#ezcontent").css("height", eval(ezcontent_height - height_diff) + "px");
		$("#EZConnect_method").css("height", eval(EZConnect_method_height - height_diff) + "px");
	}
	else
	{
		$("#container").css("height", content_height + "px");
		$("#ezcontent").css("height", ezcontent_height + "px");
		$("#EZConnect_method").css("height", EZConnect_method_height + "px");
	}

	var topForm_width = 1200;
	var ez_qrcode_container_width = 260;
	var left_fmt3_padding_left = 160;
	var browser_width = $(window).width();

	if (browser_width < topForm_width)
	{
		var max_decreasing_width = 200;
		var width_diff = eval(topForm_width - browser_width);
		width_diff = Math.min(max_decreasing_width, width_diff);

		$("#topForm").css("width", eval(topForm_width - width_diff) + "px");
		$("#ez_qrcode_container").css("width", eval(ez_qrcode_container_width - (width_diff / 2)) + "px");
		$(".left_fmt3").css("padding-left", eval(left_fmt3_padding_left - (width_diff / 2)) + "px");
	}
	else
	{
		$("#topForm").css("width", topForm_width + "px");
		$("#ez_qrcode_container").css("width", ez_qrcode_container_width + "px");
		$(".left_fmt3").css("padding-left", left_fmt3_padding_left + "px");
	}
};

$(document).ready(function()
{
	$(window).resize(fnAutoResize);
});

function loadCurrentSetting()
{
	queryCloudStatus(false);
	if ('1' == cloud_enable)
	{
		ezstatus('connected');
		DG.switches["#EZswitch"].onStatus();
	}
	else
	{
		DG.switches["#EZswitch"].offStatus();
	}
	$("#cameraID, #cameraID2").text(cloud_deviceid);
	if (cloud_deviceid.length > 0)
	{
		$("#ez_qrcode, #ez_qrcode2").qrcode({
			render       : "table",
			text         : cloud_deviceid,
			correctLevel : 0, // L: 1, M:0 , Q:3 , H:2 (default)
			width        : 100,
			height       : 100
		});
	}
	
	queryCameraName();
	$("#cameraName1, #cameraName2").text(system_hostname);

	fnAutoResize();
}

function pollServer(action, elapsed_second) 
{
	queryCloudStatus(false);

	if ("connect" == action)
	{
		if ("online" == cloud_status)
		{
			if ("" == $("#cameraID").text())
			{
				$("#cameraID, #cameraID2").text(cloud_deviceid);
				if (cloud_deviceid.length > 0)
				{
					$("#ez_qrcode, #ez_qrcode2").qrcode({
					render       : "table",
					text         : cloud_deviceid,
					correctLevel : 0, // L: 1, M:0 , Q:3 , H:2 (default)
					width        : 100,
					height       : 100
					});
				}
			}
			ezstatus('connected');
		}
		else if ("no internet" == cloud_status)
		{
			ezstatus('disconnect');
			$("#statusMsg").html("Your device is not connected to the Internet.");
		}
		else if ("maintenance" == cloud_status)
		{
			ezstatus('disconnect');
			$("#statusMsg").html("The service is currently under maintenance.");
		}
		else if ("not available" == cloud_status)
		{
			ezstatus('disconnect');
			$("#statusMsg").html("The service is currently not available.<br>Check the system log for more information.");
		}
		else if (elapsed_second > 10)
		{
			ezstatus('disconnect');
			$("#statusMsg").html("The service is currently not available.<br>Check the system log for more information.");
		}
		else
		{
			elapsed_second++;
			setTimeout(function(){ pollServer("connect", elapsed_second); }, 1000);
		}
	}
}

function EZBtnSwitchOn()
{
	setCloudService('on');
	ezstatus('connecting');
	
	setTimeout(function(){ pollServer("connect", "0"); }, 1000);
}

function EZBtnSwitchOff()
{
	$('#waringTip').foundation('open');
}

function waringTipCancel()
{
	$('#waringTip').foundation('close');
	DG.switches["#EZswitch"].onStatus();
}

function TurnOffEZConnect()
{
	$('#waringTip').foundation('close');
	setCloudService('off');
	
	ezstatus('offline');
}

function ezstatus(status)
{
	$("#shield").hide();
	
	switch (status)
	{
		case 'connecting':
			// Connecting to server
			$("#EZConnect_method").hide();
			$("#EZConnect_method_with_webrtc").hide();
			$("#ezstatus_disconnect").hide();
			$("#ezstatus_connecting").show();
			$("#shield").show(); // Disable switch button
			break;
			
		case 'connected':
			// Connect to EZConnect
			$("#EZConnect_method").show();
			$("#EZConnect_method_with_webrtc").hide();
			$("#ezstatus_disconnect").hide();
			$("#ezstatus_connecting").hide();
			break;
			
		case 'disconnect':
			// Failed to connect to server
			$("#EZConnect_method").hide();
			$("#EZConnect_method_with_webrtc").hide();
			$("#ezstatus_disconnect").show();
			$("#ezstatus_connecting").hide();
			DG.switches["#EZswitch"].offStatus();
			setCloudService('off');
			break;
			
		case 'offline':
			// off line
			$("#EZConnect_method").hide();
			$("#EZConnect_method_with_webrtc").hide();
			$("#ezstatus_disconnect").hide();
			$("#ezstatus_connecting").hide();
			break;
			
		default:
			break;
	}
}

function queryCloudStatus(bASync)
{
	var getstatus = function(){
		$.ajax({
			url: "/cloud/get_cloud_status.cgi",
			cache: false,
			async: bASync,
			type: "GET",
			dataType: "script",
			success: function(data) {
				eval(data);
			},
			error: function() {
				// Do nothing
			}
		});
	};
	getstatus();
}

function queryCameraName()
{
	var getName = function(){
		$.ajax({
			url: "/cgi-bin/admin/getparam.cgi?system_hostname",
			cache: false,
			async: false,
			type: "GET",
			dataType: "script",
			success: function(data) {
				eval(data);
			},
			error: function() {
				// Do nothing
			}
		});
	};
	getName();
}

function setCloudService(mode)
{
	var set_cloud_mode = function() {
		$.ajax({
			url: "/cloud/switch_cloud_service.cgi",
			cache: false,
			async: false,
			type: "POST",
			dataType: "script",
			data: mode,
			success: function(data) {
				eval(data);
			},
			error: function() {
				// Do nothing
			}
		});
	};
	set_cloud_mode();
}

